//+------------------------------------------------------------------+
//|                                                           Fs.mq4 |
//|                                   Copyright  2007,Sartakov S.D. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,Sartakov S.D."
#property link      "mailto:ssd@dp.ukrtel.net"
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>
//#include <Fs_Data.mqh>
//+------------------------------------------------------------------+
int _ExpertOrdersTotal = 0;    //  ,  :
int _ExpertOrdersOpen  = 0;    //  ,  :
int _ExpertOrdersLimit = 0;    //  ,  :
// ,           :
int      _OrderTicket[], _OrderType[];
double   _OrderLots[], _OrderOpenPrice[], _OrderStopLoss[], _OrderTakeProfit[];
double   _OrderProfit[], _OrderSwap[], _OrderCommission[];
datetime _OrderOpenTime[], _OrderExpiration[];
string   _OrderComment[];

//   i-           //...
string OrderCommentMes[10] = {"+Order_0","+Order_1","+Order_2","+Order_3","+Order_4","+Order_5","+Order_6","+Order_7","+Order_8","+Order_9"};
                            //            :
                            //'+' -   (),'-'  ().          /
string OrderOpenSetOkMes       = "  - / "; 
string OrderOpenSetErrorMes    = "  -  /";  

string OrderModifyOkMes        = "  -  ";   
string OrderModifyErrorMes     = "  -   "; 

string OrderDeleteOkMes        = "  -  "; 
string OrderDeleteErrorMes     = "  -   "; 
                                     

double OrderLotsSize[10];      // i-    i- ...  
int    OrderLevel[10];         //   i-      OrderLevel[i]*Point    (i-1)-
extern bool NewTradeCycleAllowed = true; //         
extern int TimeFrame = 240;              //         . 
                                         // !!!  -          !!!
                                         // !!!    -       
                                         // !!!           
                                         // !!!   , , ,  ,       

extern int MagicNumberOwn  =999;         //  - 
extern int MagicNumberAlien=888;        //   

extern int    Order_0_TakeProfit = 40;

extern int    Order_0_Level = 0;
extern double Order_0_Lots  = 0.1;

extern int    Order_1_Level = 40;
extern double Order_1_Lots  = 0.1;

extern int    Order_2_Level = 40;
extern double Order_2_Lots  = 0.1;

extern int    Order_3_Level = 45;
extern double Order_3_Lots  = 0.3;

extern int    Order_4_Level = 50;
extern double Order_4_Lots  = 0.6;

extern int    Order_5_Level = 55;
extern double Order_5_Lots  = 1.2;

extern int    Order_6_Level = 60;
extern double Order_6_Lots  = 2.0;

extern int    Order_7_Level = 60;
extern double Order_7_Lots  = 4.0;

extern int    Order_8_Level = 60;
extern double Order_8_Lots  = 9.0;

extern int    Order_9_Level = 60;
extern double Order_9_Lots  = 9.0;

int TradeDirection;      //+1  buy, -1  sell      
int TradeCycleDirectin;  //+1     buy, -1    sell,
                         //+0         
                         //        .       ,   
                         //          +0
                         //     (       )
                         //      ,    :
                         //'+' -   (),'-'  ().          /
double Tenkansen;
double Kijunsen ;
int LastError;
int i;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
// double OrderLotsSize[10]; i-    i- ...
   OrderLotsSize[0] = Order_0_Lots;
   OrderLotsSize[1] = Order_1_Lots;
   OrderLotsSize[2] = Order_2_Lots;
   OrderLotsSize[3] = Order_3_Lots;
   OrderLotsSize[4] = Order_4_Lots;
   OrderLotsSize[5] = Order_5_Lots;
   OrderLotsSize[6] = Order_6_Lots;
   OrderLotsSize[7] = Order_7_Lots;
   OrderLotsSize[8] = Order_8_Lots;
   OrderLotsSize[9] = Order_9_Lots;
// int    OrderLevel[10];    i-     OrderLevel[i]*Point
//     .        /
//   0           
   OrderLevel   [0] = Order_0_Level;
   OrderLevel   [1] = Order_1_Level;
   OrderLevel   [2] = Order_2_Level;
   OrderLevel   [3] = Order_3_Level;
   OrderLevel   [4] = Order_4_Level;
   OrderLevel   [5] = Order_5_Level;
   OrderLevel   [6] = Order_6_Level;
   OrderLevel   [7] = Order_7_Level;
   OrderLevel   [8] = Order_8_Level;
   OrderLevel   [9] = Order_9_Level;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//   ... ...       ...
//              ...
// !!!  -      extern int TimeFrame      !!!
// !!!    -       
// !!!           
// !!!   , , ,  ,       

   Tenkansen   =iIchimoku(Symbol(),TimeFrame,9,26,52,MODE_TENKANSEN,0);
   Kijunsen    =iIchimoku(Symbol(),TimeFrame,9,26,52,MODE_KIJUNSEN, 0);
   if (Tenkansen > Kijunsen) TradeDirection = +1; else TradeDirection = -1;

   AllOrdersInit(MagicNumberAlien); // , ,    ...
   if (_ExpertOrdersTotal != 0)     //   -    ,      ...                                        
     {
      TradeDirection = iif(_OrderType[0] == OP_BUY,-1,+1); //      ...
     }
   
   AllOrdersInit(MagicNumberOwn);   //     ...     ...
// ,           
//            
//         bool NewTradeCycleAllowed....
   if (OrdersOpenSet()) return(0);   //   ,  -  ,     ,  
// ,   ...
   if (OrdersModify())  return(0);   //   ,  -  ,     ,  
// ,    ...     
//        
   if (OrdersDelete())  return(0);   //   ,  -  ,     ,  
// !!! :      ,        ,
//          ,        ...
//----
   return(0); //   
  }
//+---------------------------------------------------------------------------------------------------------------+
//|                    |
//+---------------------------------------------------------------------------------------------------------------+
bool OrdersOpenSet()   // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal == 0 && NewTradeCycleAllowed) //      ,     - NewTradeCycleAllowed....
     {
      i = _ExpertOrdersTotal; //  
      _OrderType      [i] = iif(TradeDirection > 0,OP_BUY,OP_SELL);
      _OrderLots      [i] = OrderLotsSize[i];
      _OrderOpenPrice [i] = iif(TradeDirection > 0,Ask,Bid);
      _OrderStopLoss  [i] = _OrderOpenPrice[i] - TradeDirection * (OrderLevel[i+1] + OrderLevel[i+2]+ OrderLevel[i+3]) * Point; 
      _OrderTakeProfit[i] = _OrderOpenPrice[i] + TradeDirection * Order_0_TakeProfit*Point;
      _OrderComment   [i] = iifStr(TradeDirection > 0,StringSetChar(OrderCommentMes[i],0,'+'),StringSetChar(OrderCommentMes[i],0,'-'));
       _OrderSend();
       return(true);
     }
 //----
    if (_ExpertOrdersOpen != 0 && _ExpertOrdersLimit < 2)//        , 
     {
      i = _ExpertOrdersTotal; //             //       
      TradeCycleDirectin = iif(StringGetChar(_OrderComment[0],0) == '+',+1,-1);
      _OrderType      [i] = iif(TradeCycleDirectin > 0,OP_BUYLIMIT,OP_SELLLIMIT);
      _OrderLots      [i] = OrderLotsSize[i];
      _OrderOpenPrice [i] = _OrderOpenPrice[i-1]-TradeCycleDirectin * OrderLevel[i]*Point;
      _OrderStopLoss  [i] = _OrderOpenPrice[i] - TradeCycleDirectin * OrderLevel[i+1] * Point;
      _OrderStopLoss  [i] = iif(_ExpertOrdersOpen == 1,_OrderStopLoss  [0],_OrderStopLoss  [i]);
      _OrderTakeProfit[i] = _OrderOpenPrice [i-1];
      _OrderComment   [i] = iifStr(TradeCycleDirectin > 0,StringSetChar(OrderCommentMes[i],0,'+'),StringSetChar(OrderCommentMes[i],0,'-'));
      _OrderSend(); 
       return(true);
     }
//----
   return(false); //     ,        start()
   }
//+------------------------------------------------------------------+
//|               |
//|                       |
//+------------------------------------------------------------------+
bool _OrderSend()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   _OrderTicket[i]=  
        OrderSend(Symbol(),_OrderType      [i]
                          ,_OrderLots      [i]
                          ,_OrderOpenPrice [i] ,3
                          ,_OrderStopLoss  [i]
                          ,_OrderTakeProfit[i]
                          ,_OrderComment   [i]
                          ,MagicNumberOwn,0,CLR_NONE);
   if (_OrderTicket[i] < 0)
    {
     LastError = GetLastError();
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+OrderOpenSetErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
    }
   Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderOpenSetOkMes);
   PlaySound("ok.wav");
   return(true);
}           
//+---------------------------------------------------------------------------------------+
//|           |
//+---------------------------------------------------------------------------------------+
bool OrdersModify()    // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal == 0) return(false);
    if (_ExpertOrdersOpen  == 0) return(false);
    if (_ExpertOrdersOpen  == 1) return(false);
    if (_ExpertOrdersLimit  < 2) return(false);
    
    for (i = 0; i <= _ExpertOrdersTotal-2; i++) //       (   )  
     {
      if (_OrderStopLoss[i] == _OrderStopLoss[_ExpertOrdersTotal-1]) continue; //  
      _OrderStopLoss  [i] = _OrderStopLoss[_ExpertOrdersTotal-1]; 
      _OrderTakeProfit[i] = iif(i <=_ExpertOrdersTotal-4,_OrderOpenPrice[_ExpertOrdersTotal-4],_OrderTakeProfit[i]);
      _OrderModify();
      return(true); 
     }
 //----
   return(false); //     ,        start()
   }
//+--------------------------------------------------------------------+
//|                 |
//|                              |
//+--------------------------------------------------------------------+
bool _OrderModify()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderModify(_OrderTicket    [i]
                  ,_OrderOpenPrice [i]
                  ,_OrderStopLoss  [i]
                  ,_OrderTakeProfit[i]
                  ,0
                  ,CLR_NONE))
    {
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError(); if (LastError == ERR_NO_RESULT) return(true);
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }           
//+---------------------------------------------------------------------------------------+
//|     ,        |
//+---------------------------------------------------------------------------------------+
bool OrdersDelete()    // return(true) -         
   {                   // return(false)-     ,        start()
//----
    if (_ExpertOrdersTotal  == 0) return(false);
    if (_ExpertOrdersOpen   != 0) return(false);
    if (_ExpertOrdersLimit  == 0) return(false);
    i =  _ExpertOrdersTotal - 1;
    _OrderDelete();
  //----
    return(true);  
   }
//+--------------------------------------------------------------------+
//|                 |
//|                                             |
//+--------------------------------------------------------------------+
bool _OrderDelete()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderDelete(_OrderTicket[i]
                   ,CLR_NONE))
    {
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderDeleteOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError();  
     Print("("+MagicNumberOwn+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderDeleteErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }           

//+-----------------------------------------------------------------------------------------------------+
//|     ,                           |
//|  ,  .  ,                     |
//|     .             |
//|   =  _ExpertOrdersTotal + 1                                                      |
//|           /|
//|                                                                                         |
 //+----------------------------------------------------------------------------------------------------+
//"mailto:komposterius@mail.ru" -   -   
//http://www.mql4.com/ru/users/komposter  
void AllOrdersInit( int magic )
{
	int _GetLastError = 0, _OrdersTotal = OrdersTotal();
	_ExpertOrdersTotal = 0; //   ,  :
   _ExpertOrdersOpen  = 0; //   ,  :
   _ExpertOrdersLimit = 0; //   ,  :
 	//      - 
	// ( _OrdersTotal = 0,     1) 
	int temp_value = MathMax( _OrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );

	//  
	ArrayInitialize( _OrderTicket,		0 );    
	ArrayInitialize( _OrderType,			0 );
	ArrayInitialize( _OrderLots,			0 );
	ArrayInitialize( _OrderOpenPrice,	0 );
	ArrayInitialize( _OrderStopLoss,		0 );
	ArrayInitialize( _OrderTakeProfit,	0 );
	ArrayInitialize( _OrderOpenTime,		0 );
	ArrayInitialize( _OrderProfit,		0 );
	ArrayInitialize( _OrderSwap,			0 );
	ArrayInitialize( _OrderCommission,	0 );
	ArrayInitialize( _OrderExpiration,	0 );
   
 	for ( int z = 0;  z < _OrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( z, SELECT_BY_POS ) )
		{
			_GetLastError = GetLastError();
			Print("("+MagicNumberOwn+")"+ "OrderSelect( ", z, ", SELECT_BY_POS ) - Error #", _GetLastError );
			continue;
		}
		if ( OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
		{
			//    ,  
			_OrderTicket		[_ExpertOrdersTotal] = OrderTicket();
 			_ExpertOrdersTotal ++;
 	   	switch(OrderType())
           {
            case OP_BUY       : _ExpertOrdersOpen++  ; break; 
            case OP_SELL      : _ExpertOrdersOpen++  ; break;
            case OP_BUYLIMIT  : _ExpertOrdersLimit++ ; break;
            case OP_SELLLIMIT : _ExpertOrdersLimit++ ; break;
           }
		}
	}
	//     - ,   + 
	// ( _ExpertOrdersTotal = 0,     1)
	temp_value = MathMax( _ExpertOrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	
	_OrderTicket[_ExpertOrdersTotal] = 99999999;//       
   ArraySort(_OrderTicket);  //   ...
//------------------------------------------------------------------------------------------------------------------------
	for (   z = 0;  z < _ExpertOrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( _OrderTicket[z], SELECT_BY_TICKET ) )
		{
			_GetLastError = GetLastError();
			Print("("+MagicNumberOwn+")"+ "OrderSelect( ", _OrderTicket[z], ", SELECT_BY_TICKET ) - Error #", _GetLastError );
			continue;
		}
 			//   
 			_OrderType			[z] = OrderType();
			_OrderLots			[z] = NormalizeDouble( OrderLots(), 2 );
			_OrderOpenPrice	[z] = NormalizeDouble( OrderOpenPrice(), Digits );
			_OrderStopLoss		[z] = NormalizeDouble( OrderStopLoss(), Digits );
			_OrderTakeProfit	[z] = NormalizeDouble( OrderTakeProfit(), Digits );
			_OrderOpenTime		[z] = OrderOpenTime();
			_OrderProfit		[z] = NormalizeDouble( OrderProfit(), 2 );
			_OrderSwap			[z] = NormalizeDouble( OrderSwap(), 2 );
			_OrderCommission	[z] = NormalizeDouble( OrderCommission(), 2 );
			_OrderComment		[z] = OrderComment();
			_OrderExpiration	[z] = OrderExpiration();
  	}
//------------------------------------------------------------------------------------------------------------------------   
return;	
}
//------------------------------------------------------------------------------------------------------------------------   

//http://www.mql4.com/ru/users/bstone -  -  ,   (..)
//+------------------------------------------------------------------+
//| helper functions   -                                                |
//+------------------------------------------------------------------+

int sign( double v )
{
    if( v < 0 ) return( -1 );
    return( 1 );
}

//+------------------------------------------------------------------+
double iif( bool condition, double ifTrue, double ifFalse )
{
    if( condition ) return( ifTrue );
    
    return( ifFalse );
}

//+------------------------------------------------------------------+
string iifStr( bool condition, string ifTrue, string ifFalse )
{
    if( condition ) return( ifTrue );

    return( ifFalse );
}

//+------------------------------------------------------------------+
int orderDirection()
{
    return( 1 - 2 * ( OrderType() % 2 ) );
}


